/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.ergebnis;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.ergebnis.boundary.AbstractDHondtQuotientListenInGruppeSearchParameters;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientListenInGruppeChangeEvent;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientListenInGruppeConversationStore;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientListenInGruppeExtendedDAO;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientListenInGruppeSearch;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientListenInGruppeSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.ergebnis.entity.DHondtQuotientListenInGruppe;
import de.ivu.elect.business.ergebnis.entity.DHondtQuotientListenInGruppeMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractDHondtQuotientListenInGruppeSearchView.COMPONENT_NAME)
@View(viewId = AbstractDHondtQuotientListenInGruppeSearchView.VIEW_ID, useCase = UseCasePermission.D_H_QU_LISTEN_IN_GRUPPE_SEARCH)
public abstract class AbstractDHondtQuotientListenInGruppeSearchView extends AbstractElectSearchView<DHondtQuotientListenInGruppe> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "dHondtQuotientListenInGruppeSearchView";
  
  public static final String VIEW_ID = "/ergebnis/d-hondt-quotient-listen-in-gruppe-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractDHondtQuotientListenInGruppeSearchView requestHandler;

  @Inject
  private transient DHondtQuotientListenInGruppeExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(DHondtQuotientListenInGruppeConversationStore.class)
  protected transient DHondtQuotientListenInGruppeConversationStore conversationStore;

  @Inject
  protected transient DHondtQuotientListenInGruppeSearch search;

  @Inject
  @ConversationGroup(AbstractDHondtQuotientListenInGruppeSearchParameters.class)
  protected transient DHondtQuotientListenInGruppeSearchParameters searchParameters;

  @Inject
  protected transient DHondtQuotientListenInGruppeMeta entityMeta;

  public AbstractDHondtQuotientListenInGruppeSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public DHondtQuotientListenInGruppe getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(DHondtQuotientListenInGruppe entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public DHondtQuotientListenInGruppeSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<DHondtQuotientListenInGruppe> getEagerLoadingCollector() {
    return EagerLoadingCollector.<DHondtQuotientListenInGruppe> create();
  }

  @Override
  public List<DHondtQuotientListenInGruppe> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<DHondtQuotientListenInGruppe> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onDHondtQuotientListenInGruppeChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) DHondtQuotientListenInGruppeChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractDHondtQuotientListenInGruppeSearchView {

    @View
    @Inject
    private transient Instance<AbstractDHondtQuotientListenInGruppeSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractDHondtQuotientListenInGruppeSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
